#include <math.h>
#include <stdio.h>
#include "header.h"

int generate_mask(int t1, int p1){
  int points, u, ig,swapped,tmp2, index[UNDERLIERS_SIZE];
  double p[UNDERLIERS_SIZE],tmp;
  static int calls=0;

  /*   calls++; */
  /* printf("%i\n",calls);*/
  ig = 0;

  for(u=0;u<UNDERLIERS;++u){ 
    Underlier_mask[u] = 1;
    p[u] = Prob[t1][u][p1];
    index[u] = u;
  }

  do{
    swapped = 0;
    for(u=1;u<UNDERLIERS;++u){
      if(p[u] < p[u-1]){
	swapped = 1;
	tmp = p[u];
	p[u] = p[u-1];
	p[u-1] = tmp;
	tmp2 = index[u];
	index[u] = index[u-1];
	index[u-1] = tmp2;
      }
    }
  }while(swapped);

  for(u=0;u<UNDERLIERS;++u){
    if(p[u] < Prob[t1][u][p1]){
      ++ig;
    }
  }

  if(ig > MAXIGNORE) ig = MAXIGNORE;

  for(u=0; u<ig;++u){
    Underlier_mask[ index[u] ] = 0;
  }


  /*  if(PROBCUTOFF){ */
  /*     for(u=0; u<UNDERLIERS; ++u){ */
  /*       if(Prob[t1][u][p1] < PROBCUTOFF){ */
  /* 	Underlier_mask[u] = 0; */
  /* 	++ig; */
  /*       } */
  /*     } */
  /*   } */
  
  Ignore[t1] += (double)ig;
  ++Ignore_den[t1];
  return(ig);
}


/* Fill Weight[p2] with weights from (t1,p1) -> (t2,*) 
 * This is stretched out to be readable.  Variables can be 
 * eliminated and loops combined.  Includes the subterfuge.
 */
void weights1(int t1, int p1, int t2){
  int u, p2, points, eu, ig, min,found;
  double f[POINTS_SIZE], arg[POINTS_SIZE], growth[UNDERLIERS_SIZE][POINTS_SIZE],num_det,den_det;
  static double g[POINTS_SIZE];
  static int last_t2 = -1;

  /*   printf("weights1(%i,%i,%i)\n",t1,p1,t2); */

  points = points_on_timeslice(t2);
  Sum_weights = 0;

  ig = generate_mask(t1,p1);

  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[t1][u][p1]) + (t2-t1)*VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += Underlier_mask[u]*(growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))/((t2-t1)*VARIANCE);
    }
  }

  for(p2=0;p2<points;++p2){
    f[p2] = exp(-0.5*arg[p2]);
  }

  num_det = pow( sqrt((t2-t1)*VARIANCE), UNDERLIERS-ig);

  if(t2 != last_t2){ 
    last_t2 = t2; 
    
    for(p2=0;p2<points;++p2){
      arg[p2] = 0;
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	growth[u][p2] = log(Price[t2][u][p2]/Price[0][u][0]) + (t2-0)*VARIANCE/2.0;
      }
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	arg[p2] += Underlier_mask[u]*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))/((t2-0)*VARIANCE);
      }
    }
    
    for(p2=0;p2<points;++p2){
      g[p2] = exp(-0.5*arg[p2]);
    }
  }

  den_det = pow( sqrt(VARIANCE), UNDERLIERS-ig);
    
  for(p2=0;p2<points;++p2){
    Weight[p2] = 1.0/sqrt(num_det)*f[p2] /(1.0/sqrt(den_det)*g[p2]);
    Sum_weights += 1.0/sqrt(num_det)*f[p2] /(1.0/sqrt(den_det)*g[p2]);
  }
  if (Sum_weights ==0) printf("BUG\n");
}

/* Fill Weight[p2] with weights from (t1,p1) -> (t2,p2) This is
 * stretched out to be readable.  Variables can be eliminated and
 * loops combined.  Does not include the subterfuge, so it can be used
 * to calculate the probabilities needed to implement the subterfuge.
 * */

void weights2(int t1, int p1, int t2){
  int u, p2, points;
  double f[POINTS_SIZE], arg[POINTS_SIZE], growth[UNDERLIERS_SIZE][POINTS_SIZE],num_det,den_det;
  static double g[POINTS_SIZE];
  static int last_t2 = -1;

  points = points_on_timeslice(t2);
  Sum_weights = 0;

  for(p2=0;p2<points;++p2){
    arg[p2] = 0;
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      growth[u][p2] = log(Price[t2][u][p2]/Price[t1][u][p1]) + (t2-t1)*VARIANCE/2.0;
    }
  }

  for(u=0;u<UNDERLIERS;++u){
    for(p2=0;p2<points;++p2){
      arg[p2] += (growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-t1)*(INTEREST-DIVIDEND))/((t2-t1)*VARIANCE);
    }
  }

  for(p2=0;p2<points;++p2){
    f[p2] = exp(-0.5*arg[p2]);
  }

  num_det = pow( sqrt((t2-t1)*VARIANCE), UNDERLIERS);

  if(t2 != last_t2){ 
    last_t2 = t2; 
    
    for(p2=0;p2<points;++p2){
      arg[p2] = 0;
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	growth[u][p2] = log(Price[t2][u][p2]/Price[0][u][0]) + (t2-0)*VARIANCE/2.0;
      }
    }
    
    for(u=0;u<UNDERLIERS;++u){
      for(p2=0;p2<points;++p2){
	arg[p2] += (growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))*(growth[u][p2] - (t2-0)*(INTEREST-DIVIDEND))/((t2-0)*VARIANCE);
      }
    }
    
    for(p2=0;p2<points;++p2){
      g[p2] = exp(-0.5*arg[p2]);
    }
  }
    
  den_det = pow( sqrt(VARIANCE), UNDERLIERS);

  for(p2=0;p2<points;++p2){
    Weight[p2] = 1.0/sqrt(num_det)*f[p2]/(1.0/sqrt(den_det)*g[p2]);
    Sum_weights += f[p2]/g[p2];
  }
  if (Sum_weights ==0) printf("BUG\n");
}
